echo on;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Praktikum 2                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Aufgabe 1 b)
format long;
echo off;

x = -10:0.05:10;
y = x;
[x, y] = meshgrid(x, y);
z1 = x.^2 + y.^2 - 16;
[c, h] = contour(x, y, z1, -20:5:20);
clabel(c,h);
title('H�henlinienplot von x^2 + y^2 - 16');
pause;
figure(2);
z2 = (sqrt(3) + 1) * x.^2 + 4 .* y - 12*sqrt(3) -4;
[c, h] = contour(x, y, z2, -20:5:20);
clabel(c, h);
title('H�henlinienplot von sqrt(3) + 1 * x^2 + 4*y - 12*sqrt(3) - 4');

pause;


x = -4:0.1:4;
y1 = -1*sqrt(16 - x.^2);
y2 = sqrt(16 - x.^2);
y3 = 3*sqrt(3)+1-((sqrt(3)+1)/4)*x.^2;

figure(3);
plot(x, y1, x, y2, x, y3);

pause;

echo on;
%Aufgabe 1 e)
echo off;

x0 = ones(2,4);


pause;

echo on;
%Aufgabe 1 g)
echo off;

Xexakt = [ -2 2 2*sqrt(3) -2*sqrt(3); ...
          2*sqrt(3) 2*sqrt(3) -2 -2];
x0 = [ -1.9 +2.1 3.5 -3.4; ...
        3.4 3.5 -2.05 -2.1];

x0 = 1e4*x0;

for i = 1:4
    xis = newton( x0(:,i), @fs, @fsJacobi, 1e-16, 20 );
    fprintf(1, 'Loesung %2d : (%25.15f, %25.15f) \n', i, xis(1,end), xis(2,end) );
    eNorm = fehlerNorm( xis, Xexakt(:,i), 2 );
    figure(i);
    semilogy(eNorm);
end

pause;

echo on;
%Aufgabe 1 h)
echo off;

pause;

echo on;
%Aufgabe 2 c)
echo off;

n=5;
A=hilb(n);
xExakt = ones(n,1);
b = A*xExakt;
solveLGS(A,b);

pause;


relError = [];
kappa = [];
kappa(1)=0;
for n = 2:100
    H = hilb(n);
    xExakt = ones(n,1);
    b = H * xExakt;
    x = solveLGS(H, b);
    kappa(n) = cond(H, inf);
    relError(n-1) = (norm((x-xExakt), inf))/(norm(xExakt, inf))
end
relError(n)=0;
figure(5);
semilogy(kappa);
title('Kondition');
figure(6);
semilogy(relError);

pause;


echo on;
%Aufgabe 3 a)
echo off;

n = 10;
erzeugeA(n);

pause;

echo on;
%Aufgabe 3 b)
echo off;
M = inv(diag(diag(A))) * (tril(A,-1)-triu(A,1));
L = norm(M,inf);
N = (log(10^-15)*(1-L))/log(L);
A = erzeugeA(10);
x0 = zeros(10,1);
xExakt = ones(10,1);
b=A*xExakt;
%xisJacobi=jacobi(x0,A,b,N)

echo on;
%Aufgabe 3 c)
echo off;

%xisGauss= gaussSeidel(x0,A,b,10);

echo on;
%Aufgabe 3 d)
echo off;



N

xisJacobi = jacobi(x0, A, b, N);
xisGauss = gaussSeidel(x0,A,b,N);

p=inf;

eJacobi = fehlerNorm(xisJacobi, xExakt,p);
eGauss = fehlerNorm(xisGauss, xExakt,p);
pause;

echo on;
%Aufgabe 3 d) - V
echo off;

semilogy( [eJacobi eGauss] );
legend('Jacobi-Verfahren', 'GaussSeidel-Verfahren');

echo on;
%Aufgabe 3 d) - VI
echo off;

fehler = L * norm(xis(2)-xis(1), inf)