function [xis] = newton(x0, f, fJacobi, tol, nmax)

%xis = zeros(length(x0),nmax+1);
xis = [x0];
xk=x0;
k=1;
fx=f(xk);

while (k<= nmax) && (norm(fx,2) > tol)
    %keyboard;
    xk1 = xk - fJacobi(xk)\fx;
    xk = xk1;
    fx = f(xk);
    xis = [xis xk];
    k = k+1;
end

end